#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_EXTERNAL_SEMAPHORE_FD_SPEC_VERSION")]
pub const KHR_EXTERNAL_SEMAPHORE_FD_SPEC_VERSION: u32 = 1;
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
#[doc(alias = "VK_KHR_EXTERNAL_SEMAPHORE_FD_EXTENSION_NAME")]
pub const KHR_EXTERNAL_SEMAPHORE_FD_EXTENSION_NAME: *const std::os::raw::c_char = crate::cstr!("VK_KHR_external_semaphore_fd");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_GET_SEMAPHORE_FD_KHR: *const std::os::raw::c_char = crate::cstr!("vkGetSemaphoreFdKHR");
#[doc = "<s>Vulkan Manual Page</s> · Constant <br/> "]
pub const FN_IMPORT_SEMAPHORE_FD_KHR: *const std::os::raw::c_char = crate::cstr!("vkImportSemaphoreFdKHR");
#[doc = "Provided by [`crate::extensions::khr_external_semaphore_fd`]"]
impl crate::vk1_0::StructureType {
    pub const IMPORT_SEMAPHORE_FD_INFO_KHR: Self = Self(1000079000);
    pub const SEMAPHORE_GET_FD_INFO_KHR: Self = Self(1000079001);
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetSemaphoreFdKHR.html)) · Function <br/> vkGetSemaphoreFdKHR - Get a POSIX file descriptor handle for a semaphore\n[](#_c_specification)C Specification\n----------\n\nTo export a POSIX file descriptor representing the payload of a semaphore,\ncall:\n\n```\n// Provided by VK_KHR_external_semaphore_fd\nVkResult vkGetSemaphoreFdKHR(\n    VkDevice                                    device,\n    const VkSemaphoreGetFdInfoKHR*              pGetFdInfo,\n    int*                                        pFd);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the logical device that created the semaphore being\n  exported.\n\n* [`Self::p_get_fd_info`] is a pointer to a [`crate::vk::SemaphoreGetFdInfoKHR`]structure containing parameters of the export operation.\n\n* [`Self::p_fd`] will return the file descriptor representing the semaphore\n  payload.\n[](#_description)Description\n----------\n\nEach call to [`crate::vk::DeviceLoader::get_semaphore_fd_khr`] **must** create a new file descriptor\nand transfer ownership of it to the application.\nTo avoid leaking resources, the application **must** release ownership of the\nfile descriptor when it is no longer needed.\n\n|   |Note<br/><br/>Ownership can be released in many ways.<br/>For example, the application can call `close`() on the file descriptor,<br/>or transfer ownership back to Vulkan by using the file descriptor to import<br/>a semaphore payload.|\n|---|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nWhere supported by the operating system, the implementation **must** set the\nfile descriptor to be closed automatically when an `execve` system call\nis made.\n\nExporting a file descriptor from a semaphore **may** have side effects\ndepending on the transference of the specified handle type, as described in[Importing Semaphore State](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphores-importing).\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetSemaphoreFdKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetSemaphoreFdKHR-pGetFdInfo-parameter  \n  [`Self::p_get_fd_info`] **must** be a valid pointer to a valid [`crate::vk::SemaphoreGetFdInfoKHR`] structure\n\n* []() VUID-vkGetSemaphoreFdKHR-pFd-parameter  \n  [`Self::p_fd`] **must** be a valid pointer to an `int` value\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_TOO_MANY_OBJECTS`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::SemaphoreGetFdInfoKHR`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkGetSemaphoreFdKHR = unsafe extern "system" fn(device: crate::vk1_0::Device, p_get_fd_info: *const crate::extensions::khr_external_semaphore_fd::SemaphoreGetFdInfoKHR, p_fd: *mut std::os::raw::c_int) -> crate::vk1_0::Result;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkImportSemaphoreFdKHR.html)) · Function <br/> vkImportSemaphoreFdKHR - Import a semaphore from a POSIX file descriptor\n[](#_c_specification)C Specification\n----------\n\nTo import a semaphore payload from a POSIX file descriptor, call:\n\n```\n// Provided by VK_KHR_external_semaphore_fd\nVkResult vkImportSemaphoreFdKHR(\n    VkDevice                                    device,\n    const VkImportSemaphoreFdInfoKHR*           pImportSemaphoreFdInfo);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the logical device that created the semaphore.\n\n* [`Self::p_import_semaphore_fd_info`] is a pointer to a[`crate::vk::ImportSemaphoreFdInfoKHR`] structure specifying the semaphore and\n  import parameters.\n[](#_description)Description\n----------\n\nImporting a semaphore payload from a file descriptor transfers ownership of\nthe file descriptor from the application to the Vulkan implementation.\nThe application **must** not perform any operations on the file descriptor\nafter a successful import.\n\nApplications **can** import the same semaphore payload into multiple instances\nof Vulkan, into the same instance from which it was exported, and multiple\ntimes into a given Vulkan instance.\n\nValid Usage\n\n* []() VUID-vkImportSemaphoreFdKHR-semaphore-01142  \n  `semaphore` **must** not be associated with any queue command that has\n  not yet completed execution on that queue\n\nValid Usage (Implicit)\n\n* []() VUID-vkImportSemaphoreFdKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkImportSemaphoreFdKHR-pImportSemaphoreFdInfo-parameter  \n  [`Self::p_import_semaphore_fd_info`] **must** be a valid pointer to a valid [`crate::vk::ImportSemaphoreFdInfoKHR`] structure\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_INVALID_EXTERNAL_HANDLE`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::ImportSemaphoreFdInfoKHR`]\n"]
#[allow(non_camel_case_types)]
pub type PFN_vkImportSemaphoreFdKHR = unsafe extern "system" fn(device: crate::vk1_0::Device, p_import_semaphore_fd_info: *const crate::extensions::khr_external_semaphore_fd::ImportSemaphoreFdInfoKHR) -> crate::vk1_0::Result;
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkImportSemaphoreFdInfoKHR.html)) · Structure <br/> VkImportSemaphoreFdInfoKHR - Structure specifying POSIX file descriptor to import to a semaphore\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ImportSemaphoreFdInfoKHR`] structure is defined as:\n\n```\n// Provided by VK_KHR_external_semaphore_fd\ntypedef struct VkImportSemaphoreFdInfoKHR {\n    VkStructureType                          sType;\n    const void*                              pNext;\n    VkSemaphore                              semaphore;\n    VkSemaphoreImportFlags                   flags;\n    VkExternalSemaphoreHandleTypeFlagBits    handleType;\n    int                                      fd;\n} VkImportSemaphoreFdInfoKHR;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* [`Self::semaphore`] is the semaphore into which the payload will be\n  imported.\n\n* [`Self::flags`] is a bitmask of [VkSemaphoreImportFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreImportFlagBits.html) specifying\n  additional parameters for the semaphore payload import operation.\n\n* [`Self::handle_type`] is a [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) value\n  specifying the type of [`Self::fd`].\n\n* [`Self::fd`] is the external handle to import.\n[](#_description)Description\n----------\n\nThe handle types supported by [`Self::handle_type`] are:\n\n|                   Handle Type                   |Transference|Permanence Supported|\n|-------------------------------------------------|------------|--------------------|\n|[`crate::vk::ExternalSemaphoreHandleTypeFlagBits::OPAQUE_FD`]| Reference  |Temporary,Permanent |\n| [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::SYNC_FD`] |    Copy    |     Temporary      |\n\nValid Usage\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-handleType-01143  \n  [`Self::handle_type`] **must** be a value included in the[Handle Types Supported by[`crate::vk::ImportSemaphoreFdInfoKHR`]](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphore-handletypes-fd) table\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-fd-01544  \n  [`Self::fd`] **must** obey any requirements listed for [`Self::handle_type`] in[external semaphore\n  handle types compatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#external-semaphore-handle-types-compatibility)\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-handleType-03263  \n   If [`Self::handle_type`] is[`crate::vk::ExternalSemaphoreHandleTypeFlagBits::OPAQUE_FD`], the[`crate::vk::SemaphoreCreateInfo::flags`] field **must** match that of the\n  semaphore from which [`Self::fd`] was exported\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-handleType-03264  \n   If [`Self::handle_type`] is[`crate::vk::ExternalSemaphoreHandleTypeFlagBits::OPAQUE_FD`], the[`crate::vk::SemaphoreTypeCreateInfo::semaphore_type`] field **must** match\n  that of the semaphore from which [`Self::fd`] was exported\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-flags-03323  \n   If [`Self::flags`] contains [`crate::vk::SemaphoreImportFlagBits::TEMPORARY`], the[`crate::vk::SemaphoreTypeCreateInfo::semaphore_type`] field of the\n  semaphore from which [`Self::fd`] was exported **must** not be[`crate::vk::SemaphoreType::TIMELINE`]\n\nIf [`Self::handle_type`] is [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::SYNC_FD`],\nthe special value `-1` for [`Self::fd`] is treated like a valid sync file\ndescriptor referring to an object that has already signaled.\nThe import operation will succeed and the [`crate::vk::Semaphore`] will have a\ntemporarily imported payload as if a valid file descriptor had been\nprovided.\n\n|   |Note<br/><br/>This special behavior for importing an invalid sync file descriptor allows<br/>easier interoperability with other system APIs which use the convention that<br/>an invalid sync file descriptor represents work that has already completed<br/>and does not need to be waited for.<br/>It is consistent with the option for implementations to return a `-1` file<br/>descriptor when exporting a[`crate::vk::ExternalSemaphoreHandleTypeFlagBits::SYNC_FD`] from a [`crate::vk::Semaphore`]which is signaled.|\n|---|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage (Implicit)\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::IMPORT_SEMAPHORE_FD_INFO_KHR`]\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-pNext-pNext  \n  [`Self::p_next`] **must** be `NULL`\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-semaphore-parameter  \n  [`Self::semaphore`] **must** be a valid [`crate::vk::Semaphore`] handle\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-flags-parameter  \n  [`Self::flags`] **must** be a valid combination of [VkSemaphoreImportFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreImportFlagBits.html) values\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-handleType-parameter  \n  [`Self::handle_type`] **must** be a valid [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) value\n\nHost Synchronization\n\n* Host access to [`Self::semaphore`] **must** be externally synchronized\n[](#_see_also)See Also\n----------\n\n[VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html), [`crate::vk::Semaphore`], [`crate::vk::SemaphoreImportFlagBits`], [`crate::vk::StructureType`], [`crate::vk::DeviceLoader::import_semaphore_fd_khr`]\n"]
#[doc(alias = "VkImportSemaphoreFdInfoKHR")]
#[derive(Copy, Clone)]
#[repr(C)]
pub struct ImportSemaphoreFdInfoKHR {
    pub s_type: crate::vk1_0::StructureType,
    pub p_next: *const std::ffi::c_void,
    pub semaphore: crate::vk1_0::Semaphore,
    pub flags: crate::vk1_1::SemaphoreImportFlags,
    pub handle_type: crate::vk1_1::ExternalSemaphoreHandleTypeFlagBits,
    pub fd: std::os::raw::c_int,
}
impl ImportSemaphoreFdInfoKHR {
    pub const STRUCTURE_TYPE: crate::vk1_0::StructureType = crate::vk1_0::StructureType::IMPORT_SEMAPHORE_FD_INFO_KHR;
}
impl Default for ImportSemaphoreFdInfoKHR {
    fn default() -> Self {
        Self { s_type: Self::STRUCTURE_TYPE, p_next: std::ptr::null(), semaphore: Default::default(), flags: Default::default(), handle_type: Default::default(), fd: Default::default() }
    }
}
impl std::fmt::Debug for ImportSemaphoreFdInfoKHR {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.debug_struct("ImportSemaphoreFdInfoKHR").field("s_type", &self.s_type).field("p_next", &self.p_next).field("semaphore", &self.semaphore).field("flags", &self.flags).field("handle_type", &self.handle_type).field("fd", &self.fd).finish()
    }
}
impl ImportSemaphoreFdInfoKHR {
    #[inline]
    pub fn into_builder<'a>(self) -> ImportSemaphoreFdInfoKHRBuilder<'a> {
        ImportSemaphoreFdInfoKHRBuilder(self, std::marker::PhantomData)
    }
}
#[derive(Copy, Clone)]
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkImportSemaphoreFdInfoKHR.html)) · Builder of [`ImportSemaphoreFdInfoKHR`] <br/> VkImportSemaphoreFdInfoKHR - Structure specifying POSIX file descriptor to import to a semaphore\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::ImportSemaphoreFdInfoKHR`] structure is defined as:\n\n```\n// Provided by VK_KHR_external_semaphore_fd\ntypedef struct VkImportSemaphoreFdInfoKHR {\n    VkStructureType                          sType;\n    const void*                              pNext;\n    VkSemaphore                              semaphore;\n    VkSemaphoreImportFlags                   flags;\n    VkExternalSemaphoreHandleTypeFlagBits    handleType;\n    int                                      fd;\n} VkImportSemaphoreFdInfoKHR;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* [`Self::semaphore`] is the semaphore into which the payload will be\n  imported.\n\n* [`Self::flags`] is a bitmask of [VkSemaphoreImportFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreImportFlagBits.html) specifying\n  additional parameters for the semaphore payload import operation.\n\n* [`Self::handle_type`] is a [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) value\n  specifying the type of [`Self::fd`].\n\n* [`Self::fd`] is the external handle to import.\n[](#_description)Description\n----------\n\nThe handle types supported by [`Self::handle_type`] are:\n\n|                   Handle Type                   |Transference|Permanence Supported|\n|-------------------------------------------------|------------|--------------------|\n|[`crate::vk::ExternalSemaphoreHandleTypeFlagBits::OPAQUE_FD`]| Reference  |Temporary,Permanent |\n| [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::SYNC_FD`] |    Copy    |     Temporary      |\n\nValid Usage\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-handleType-01143  \n  [`Self::handle_type`] **must** be a value included in the[Handle Types Supported by[`crate::vk::ImportSemaphoreFdInfoKHR`]](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphore-handletypes-fd) table\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-fd-01544  \n  [`Self::fd`] **must** obey any requirements listed for [`Self::handle_type`] in[external semaphore\n  handle types compatibility](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#external-semaphore-handle-types-compatibility)\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-handleType-03263  \n   If [`Self::handle_type`] is[`crate::vk::ExternalSemaphoreHandleTypeFlagBits::OPAQUE_FD`], the[`crate::vk::SemaphoreCreateInfo::flags`] field **must** match that of the\n  semaphore from which [`Self::fd`] was exported\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-handleType-03264  \n   If [`Self::handle_type`] is[`crate::vk::ExternalSemaphoreHandleTypeFlagBits::OPAQUE_FD`], the[`crate::vk::SemaphoreTypeCreateInfo::semaphore_type`] field **must** match\n  that of the semaphore from which [`Self::fd`] was exported\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-flags-03323  \n   If [`Self::flags`] contains [`crate::vk::SemaphoreImportFlagBits::TEMPORARY`], the[`crate::vk::SemaphoreTypeCreateInfo::semaphore_type`] field of the\n  semaphore from which [`Self::fd`] was exported **must** not be[`crate::vk::SemaphoreType::TIMELINE`]\n\nIf [`Self::handle_type`] is [`crate::vk::ExternalSemaphoreHandleTypeFlagBits::SYNC_FD`],\nthe special value `-1` for [`Self::fd`] is treated like a valid sync file\ndescriptor referring to an object that has already signaled.\nThe import operation will succeed and the [`crate::vk::Semaphore`] will have a\ntemporarily imported payload as if a valid file descriptor had been\nprovided.\n\n|   |Note<br/><br/>This special behavior for importing an invalid sync file descriptor allows<br/>easier interoperability with other system APIs which use the convention that<br/>an invalid sync file descriptor represents work that has already completed<br/>and does not need to be waited for.<br/>It is consistent with the option for implementations to return a `-1` file<br/>descriptor when exporting a[`crate::vk::ExternalSemaphoreHandleTypeFlagBits::SYNC_FD`] from a [`crate::vk::Semaphore`]which is signaled.|\n|---|-----------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nValid Usage (Implicit)\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::IMPORT_SEMAPHORE_FD_INFO_KHR`]\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-pNext-pNext  \n  [`Self::p_next`] **must** be `NULL`\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-semaphore-parameter  \n  [`Self::semaphore`] **must** be a valid [`crate::vk::Semaphore`] handle\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-flags-parameter  \n  [`Self::flags`] **must** be a valid combination of [VkSemaphoreImportFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreImportFlagBits.html) values\n\n* []() VUID-VkImportSemaphoreFdInfoKHR-handleType-parameter  \n  [`Self::handle_type`] **must** be a valid [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) value\n\nHost Synchronization\n\n* Host access to [`Self::semaphore`] **must** be externally synchronized\n[](#_see_also)See Also\n----------\n\n[VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html), [`crate::vk::Semaphore`], [`crate::vk::SemaphoreImportFlagBits`], [`crate::vk::StructureType`], [`crate::vk::DeviceLoader::import_semaphore_fd_khr`]\n"]
#[repr(transparent)]
pub struct ImportSemaphoreFdInfoKHRBuilder<'a>(ImportSemaphoreFdInfoKHR, std::marker::PhantomData<&'a ()>);
impl<'a> ImportSemaphoreFdInfoKHRBuilder<'a> {
    #[inline]
    pub fn new() -> ImportSemaphoreFdInfoKHRBuilder<'a> {
        ImportSemaphoreFdInfoKHRBuilder(Default::default(), std::marker::PhantomData)
    }
    #[inline]
    pub fn semaphore(mut self, semaphore: crate::vk1_0::Semaphore) -> Self {
        self.0.semaphore = semaphore as _;
        self
    }
    #[inline]
    pub fn flags(mut self, flags: crate::vk1_1::SemaphoreImportFlags) -> Self {
        self.0.flags = flags as _;
        self
    }
    #[inline]
    pub fn handle_type(mut self, handle_type: crate::vk1_1::ExternalSemaphoreHandleTypeFlagBits) -> Self {
        self.0.handle_type = handle_type as _;
        self
    }
    #[inline]
    pub fn fd(mut self, fd: std::os::raw::c_int) -> Self {
        self.0.fd = fd as _;
        self
    }
    #[inline]
    #[doc = r" Discards all lifetime information."]
    #[doc = r" Use the `Deref` and `DerefMut` implementations if possible."]
    pub fn build(self) -> ImportSemaphoreFdInfoKHR {
        self.0
    }
}
impl<'a> std::default::Default for ImportSemaphoreFdInfoKHRBuilder<'a> {
    fn default() -> ImportSemaphoreFdInfoKHRBuilder<'a> {
        Self::new()
    }
}
impl<'a> std::fmt::Debug for ImportSemaphoreFdInfoKHRBuilder<'a> {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        std::fmt::Debug::fmt(&self.0, f)
    }
}
impl<'a> std::ops::Deref for ImportSemaphoreFdInfoKHRBuilder<'a> {
    type Target = ImportSemaphoreFdInfoKHR;
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl<'a> std::ops::DerefMut for ImportSemaphoreFdInfoKHRBuilder<'a> {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreGetFdInfoKHR.html)) · Structure <br/> VkSemaphoreGetFdInfoKHR - Structure describing a POSIX FD semaphore export operation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SemaphoreGetFdInfoKHR`] structure is defined as:\n\n```\n// Provided by VK_KHR_external_semaphore_fd\ntypedef struct VkSemaphoreGetFdInfoKHR {\n    VkStructureType                          sType;\n    const void*                              pNext;\n    VkSemaphore                              semaphore;\n    VkExternalSemaphoreHandleTypeFlagBits    handleType;\n} VkSemaphoreGetFdInfoKHR;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* [`Self::semaphore`] is the semaphore from which state will be exported.\n\n* [`Self::handle_type`] is a [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) value\n  specifying the type of handle requested.\n[](#_description)Description\n----------\n\nThe properties of the file descriptor returned depend on the value of[`Self::handle_type`].\nSee [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) for a description of the\nproperties of the defined external semaphore handle types.\n\nValid Usage\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-01132  \n  [`Self::handle_type`] **must** have been included in[`crate::vk::ExportSemaphoreCreateInfo::handle_types`] when[`Self::semaphore`]’s current payload was created\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-semaphore-01133  \n  [`Self::semaphore`] **must** not currently have its payload replaced by an\n  imported payload as described below in[Importing Semaphore Payloads](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphores-importing)unless that imported payload’s handle type was included in[`crate::vk::ExternalSemaphoreProperties::export_from_imported_handle_types`]for [`Self::handle_type`]\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-01134  \n   If [`Self::handle_type`] refers to a handle type with copy payload\n  transference semantics, as defined below in[Importing Semaphore Payloads](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphores-importing),\n  there **must** be no queue waiting on [`Self::semaphore`]\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-01135  \n   If [`Self::handle_type`] refers to a handle type with copy payload\n  transference semantics, [`Self::semaphore`] **must** be signaled, or have an\n  associated [semaphore signal\n  operation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphores-signaling) pending execution\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-01136  \n  [`Self::handle_type`] **must** be defined as a POSIX file descriptor handle\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-03253  \n   If [`Self::handle_type`] refers to a handle type with copy payload\n  transference semantics, [`Self::semaphore`] **must** have been created with a[`crate::vk::SemaphoreType`] of [`crate::vk::SemaphoreType::BINARY`]\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-03254  \n   If [`Self::handle_type`] refers to a handle type with copy payload\n  transference semantics, [`Self::semaphore`] **must** have an associated\n  semaphore signal operation that has been submitted for execution and any\n  semaphore signal operations on which it depends (if any) **must** have also\n  been submitted for execution\n\nValid Usage (Implicit)\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::SEMAPHORE_GET_FD_INFO_KHR`]\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-pNext-pNext  \n  [`Self::p_next`] **must** be `NULL`\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-semaphore-parameter  \n  [`Self::semaphore`] **must** be a valid [`crate::vk::Semaphore`] handle\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-parameter  \n  [`Self::handle_type`] **must** be a valid [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) value\n[](#_see_also)See Also\n----------\n\n[VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html), [`crate::vk::Semaphore`], [`crate::vk::StructureType`], [`crate::vk::DeviceLoader::get_semaphore_fd_khr`]\n"]
#[doc(alias = "VkSemaphoreGetFdInfoKHR")]
#[derive(Copy, Clone)]
#[repr(C)]
pub struct SemaphoreGetFdInfoKHR {
    pub s_type: crate::vk1_0::StructureType,
    pub p_next: *const std::ffi::c_void,
    pub semaphore: crate::vk1_0::Semaphore,
    pub handle_type: crate::vk1_1::ExternalSemaphoreHandleTypeFlagBits,
}
impl SemaphoreGetFdInfoKHR {
    pub const STRUCTURE_TYPE: crate::vk1_0::StructureType = crate::vk1_0::StructureType::SEMAPHORE_GET_FD_INFO_KHR;
}
impl Default for SemaphoreGetFdInfoKHR {
    fn default() -> Self {
        Self { s_type: Self::STRUCTURE_TYPE, p_next: std::ptr::null(), semaphore: Default::default(), handle_type: Default::default() }
    }
}
impl std::fmt::Debug for SemaphoreGetFdInfoKHR {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        f.debug_struct("SemaphoreGetFdInfoKHR").field("s_type", &self.s_type).field("p_next", &self.p_next).field("semaphore", &self.semaphore).field("handle_type", &self.handle_type).finish()
    }
}
impl SemaphoreGetFdInfoKHR {
    #[inline]
    pub fn into_builder<'a>(self) -> SemaphoreGetFdInfoKHRBuilder<'a> {
        SemaphoreGetFdInfoKHRBuilder(self, std::marker::PhantomData)
    }
}
#[derive(Copy, Clone)]
#[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkSemaphoreGetFdInfoKHR.html)) · Builder of [`SemaphoreGetFdInfoKHR`] <br/> VkSemaphoreGetFdInfoKHR - Structure describing a POSIX FD semaphore export operation\n[](#_c_specification)C Specification\n----------\n\nThe [`crate::vk::SemaphoreGetFdInfoKHR`] structure is defined as:\n\n```\n// Provided by VK_KHR_external_semaphore_fd\ntypedef struct VkSemaphoreGetFdInfoKHR {\n    VkStructureType                          sType;\n    const void*                              pNext;\n    VkSemaphore                              semaphore;\n    VkExternalSemaphoreHandleTypeFlagBits    handleType;\n} VkSemaphoreGetFdInfoKHR;\n```\n[](#_members)Members\n----------\n\n* [`Self::s_type`] is the type of this structure.\n\n* [`Self::p_next`] is `NULL` or a pointer to a structure extending this\n  structure.\n\n* [`Self::semaphore`] is the semaphore from which state will be exported.\n\n* [`Self::handle_type`] is a [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) value\n  specifying the type of handle requested.\n[](#_description)Description\n----------\n\nThe properties of the file descriptor returned depend on the value of[`Self::handle_type`].\nSee [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) for a description of the\nproperties of the defined external semaphore handle types.\n\nValid Usage\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-01132  \n  [`Self::handle_type`] **must** have been included in[`crate::vk::ExportSemaphoreCreateInfo::handle_types`] when[`Self::semaphore`]’s current payload was created\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-semaphore-01133  \n  [`Self::semaphore`] **must** not currently have its payload replaced by an\n  imported payload as described below in[Importing Semaphore Payloads](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphores-importing)unless that imported payload’s handle type was included in[`crate::vk::ExternalSemaphoreProperties::export_from_imported_handle_types`]for [`Self::handle_type`]\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-01134  \n   If [`Self::handle_type`] refers to a handle type with copy payload\n  transference semantics, as defined below in[Importing Semaphore Payloads](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphores-importing),\n  there **must** be no queue waiting on [`Self::semaphore`]\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-01135  \n   If [`Self::handle_type`] refers to a handle type with copy payload\n  transference semantics, [`Self::semaphore`] **must** be signaled, or have an\n  associated [semaphore signal\n  operation](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphores-signaling) pending execution\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-01136  \n  [`Self::handle_type`] **must** be defined as a POSIX file descriptor handle\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-03253  \n   If [`Self::handle_type`] refers to a handle type with copy payload\n  transference semantics, [`Self::semaphore`] **must** have been created with a[`crate::vk::SemaphoreType`] of [`crate::vk::SemaphoreType::BINARY`]\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-03254  \n   If [`Self::handle_type`] refers to a handle type with copy payload\n  transference semantics, [`Self::semaphore`] **must** have an associated\n  semaphore signal operation that has been submitted for execution and any\n  semaphore signal operations on which it depends (if any) **must** have also\n  been submitted for execution\n\nValid Usage (Implicit)\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-sType-sType  \n  [`Self::s_type`] **must** be [`crate::vk::StructureType::SEMAPHORE_GET_FD_INFO_KHR`]\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-pNext-pNext  \n  [`Self::p_next`] **must** be `NULL`\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-semaphore-parameter  \n  [`Self::semaphore`] **must** be a valid [`crate::vk::Semaphore`] handle\n\n* []() VUID-VkSemaphoreGetFdInfoKHR-handleType-parameter  \n  [`Self::handle_type`] **must** be a valid [VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html) value\n[](#_see_also)See Also\n----------\n\n[VkExternalSemaphoreHandleTypeFlagBits](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/VkExternalSemaphoreHandleTypeFlagBits.html), [`crate::vk::Semaphore`], [`crate::vk::StructureType`], [`crate::vk::DeviceLoader::get_semaphore_fd_khr`]\n"]
#[repr(transparent)]
pub struct SemaphoreGetFdInfoKHRBuilder<'a>(SemaphoreGetFdInfoKHR, std::marker::PhantomData<&'a ()>);
impl<'a> SemaphoreGetFdInfoKHRBuilder<'a> {
    #[inline]
    pub fn new() -> SemaphoreGetFdInfoKHRBuilder<'a> {
        SemaphoreGetFdInfoKHRBuilder(Default::default(), std::marker::PhantomData)
    }
    #[inline]
    pub fn semaphore(mut self, semaphore: crate::vk1_0::Semaphore) -> Self {
        self.0.semaphore = semaphore as _;
        self
    }
    #[inline]
    pub fn handle_type(mut self, handle_type: crate::vk1_1::ExternalSemaphoreHandleTypeFlagBits) -> Self {
        self.0.handle_type = handle_type as _;
        self
    }
    #[inline]
    #[doc = r" Discards all lifetime information."]
    #[doc = r" Use the `Deref` and `DerefMut` implementations if possible."]
    pub fn build(self) -> SemaphoreGetFdInfoKHR {
        self.0
    }
}
impl<'a> std::default::Default for SemaphoreGetFdInfoKHRBuilder<'a> {
    fn default() -> SemaphoreGetFdInfoKHRBuilder<'a> {
        Self::new()
    }
}
impl<'a> std::fmt::Debug for SemaphoreGetFdInfoKHRBuilder<'a> {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        std::fmt::Debug::fmt(&self.0, f)
    }
}
impl<'a> std::ops::Deref for SemaphoreGetFdInfoKHRBuilder<'a> {
    type Target = SemaphoreGetFdInfoKHR;
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl<'a> std::ops::DerefMut for SemaphoreGetFdInfoKHRBuilder<'a> {
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
#[doc = "Provided by [`crate::extensions::khr_external_semaphore_fd`]"]
impl crate::DeviceLoader {
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkGetSemaphoreFdKHR.html)) · Function <br/> vkGetSemaphoreFdKHR - Get a POSIX file descriptor handle for a semaphore\n[](#_c_specification)C Specification\n----------\n\nTo export a POSIX file descriptor representing the payload of a semaphore,\ncall:\n\n```\n// Provided by VK_KHR_external_semaphore_fd\nVkResult vkGetSemaphoreFdKHR(\n    VkDevice                                    device,\n    const VkSemaphoreGetFdInfoKHR*              pGetFdInfo,\n    int*                                        pFd);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the logical device that created the semaphore being\n  exported.\n\n* [`Self::p_get_fd_info`] is a pointer to a [`crate::vk::SemaphoreGetFdInfoKHR`]structure containing parameters of the export operation.\n\n* [`Self::p_fd`] will return the file descriptor representing the semaphore\n  payload.\n[](#_description)Description\n----------\n\nEach call to [`crate::vk::DeviceLoader::get_semaphore_fd_khr`] **must** create a new file descriptor\nand transfer ownership of it to the application.\nTo avoid leaking resources, the application **must** release ownership of the\nfile descriptor when it is no longer needed.\n\n|   |Note<br/><br/>Ownership can be released in many ways.<br/>For example, the application can call `close`() on the file descriptor,<br/>or transfer ownership back to Vulkan by using the file descriptor to import<br/>a semaphore payload.|\n|---|------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------|\n\nWhere supported by the operating system, the implementation **must** set the\nfile descriptor to be closed automatically when an `execve` system call\nis made.\n\nExporting a file descriptor from a semaphore **may** have side effects\ndepending on the transference of the specified handle type, as described in[Importing Semaphore State](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/html/vkspec.html#synchronization-semaphores-importing).\n\nValid Usage (Implicit)\n\n* []() VUID-vkGetSemaphoreFdKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkGetSemaphoreFdKHR-pGetFdInfo-parameter  \n  [`Self::p_get_fd_info`] **must** be a valid pointer to a valid [`crate::vk::SemaphoreGetFdInfoKHR`] structure\n\n* []() VUID-vkGetSemaphoreFdKHR-pFd-parameter  \n  [`Self::p_fd`] **must** be a valid pointer to an `int` value\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_TOO_MANY_OBJECTS`]\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::SemaphoreGetFdInfoKHR`]\n"]
    #[doc(alias = "vkGetSemaphoreFdKHR")]
    pub unsafe fn get_semaphore_fd_khr(&self, get_fd_info: &crate::extensions::khr_external_semaphore_fd::SemaphoreGetFdInfoKHR) -> crate::utils::VulkanResult<std::os::raw::c_int> {
        let _function = self.get_semaphore_fd_khr.expect(crate::NOT_LOADED_MESSAGE);
        let mut fd = Default::default();
        let _return = _function(self.handle, get_fd_info as _, &mut fd);
        crate::utils::VulkanResult::new(_return, fd)
    }
    #[inline]
    #[track_caller]
    #[doc = "[Vulkan Manual Page](https://www.khronos.org/registry/vulkan/specs/1.2-extensions/man/html/vkImportSemaphoreFdKHR.html)) · Function <br/> vkImportSemaphoreFdKHR - Import a semaphore from a POSIX file descriptor\n[](#_c_specification)C Specification\n----------\n\nTo import a semaphore payload from a POSIX file descriptor, call:\n\n```\n// Provided by VK_KHR_external_semaphore_fd\nVkResult vkImportSemaphoreFdKHR(\n    VkDevice                                    device,\n    const VkImportSemaphoreFdInfoKHR*           pImportSemaphoreFdInfo);\n```\n[](#_parameters)Parameters\n----------\n\n* [`Self::device`] is the logical device that created the semaphore.\n\n* [`Self::p_import_semaphore_fd_info`] is a pointer to a[`crate::vk::ImportSemaphoreFdInfoKHR`] structure specifying the semaphore and\n  import parameters.\n[](#_description)Description\n----------\n\nImporting a semaphore payload from a file descriptor transfers ownership of\nthe file descriptor from the application to the Vulkan implementation.\nThe application **must** not perform any operations on the file descriptor\nafter a successful import.\n\nApplications **can** import the same semaphore payload into multiple instances\nof Vulkan, into the same instance from which it was exported, and multiple\ntimes into a given Vulkan instance.\n\nValid Usage\n\n* []() VUID-vkImportSemaphoreFdKHR-semaphore-01142  \n  `semaphore` **must** not be associated with any queue command that has\n  not yet completed execution on that queue\n\nValid Usage (Implicit)\n\n* []() VUID-vkImportSemaphoreFdKHR-device-parameter  \n  [`Self::device`] **must** be a valid [`crate::vk::Device`] handle\n\n* []() VUID-vkImportSemaphoreFdKHR-pImportSemaphoreFdInfo-parameter  \n  [`Self::p_import_semaphore_fd_info`] **must** be a valid pointer to a valid [`crate::vk::ImportSemaphoreFdInfoKHR`] structure\n\nReturn Codes\n\nOn success, this command returns\n\n* [`crate::vk::Result::SUCCESS`]\n\nOn failure, this command returns\n\n* [`crate::vk::Result::ERROR_OUT_OF_HOST_MEMORY`]\n\n* [`crate::vk::Result::ERROR_INVALID_EXTERNAL_HANDLE`]\n[](#_see_also)See Also\n----------\n\n[`crate::vk::Device`], [`crate::vk::ImportSemaphoreFdInfoKHR`]\n"]
    #[doc(alias = "vkImportSemaphoreFdKHR")]
    pub unsafe fn import_semaphore_fd_khr(&self, import_semaphore_fd_info: &crate::extensions::khr_external_semaphore_fd::ImportSemaphoreFdInfoKHR) -> crate::utils::VulkanResult<()> {
        let _function = self.import_semaphore_fd_khr.expect(crate::NOT_LOADED_MESSAGE);
        let _return = _function(self.handle, import_semaphore_fd_info as _);
        crate::utils::VulkanResult::new(_return, ())
    }
}
